.equ Enter, 0x0A
.equ CR   , 0x0D

.org 0x100
  ; Interrupts sperren
  mov 0xA8,#0x00 ; IEN0-Register

  ; RMAP einschalten
    mov a,SYSCON
    orl a,#0x10
    mov SYSCON,a

  ; A/D-Kanal 0 einschalten
  mov P1,#0x01 ; P1ANA

  ; RMAP ausschalten
  mov a,SYSCON
  anl a,#0xEF
  mov SYSCON,a

  ; A/D-Wandler konfigurieren
  mov 0xD8,#0x00 ; ADCON0-Register
  mov 0xD9,#0x00 ; ADCON1-Register

Hauptschleife:

  ; Messung starten
  mov 0xDA,#0x00 ; ADDATL-Register
  ; Warten bis Busy-Bit gelscht
  Warten: jb 0xD8.4, Warten

  mov  a,0xD9 ; ADDATH-Register
  lcall SendByte

  mov  a,0xDA ; ADDATL-Register
  lcall SendByte

  w1: jnb TI,w1
  clr TI
  mov SBUF,#Enter

  w2: jnb TI,w2
  clr TI
  mov SBUF,#CR

  ljmp Hauptschleife


; =======================================================
; Byte aus a in ASCII-Code umwandeln und ber die serielle
; Schnittstelle versenden.

SendByte:
  push ACC
  anl a,#0xF0
  rr a
  rr a
  rr a
  rr a

  lcall HalbConvertToASCII

  w1: jnb TI,w1
  clr TI
  mov SBUF,a

  pop ACC
  anl a,#0x0F

  lcall HalbConvertToASCII

  w2: jnb TI,w2
  clr TI
  mov SBUF,a

  ret

HalbConvertToASCII:
  push ACC
  clr c
  subb a,#0x0A
  pop ACC
  jc ZahlToASCII
  add a,#55
  ret
ZahlToASCII:
  add a,#48
  ret

.end
